package com.flossom.system.service.impl;

import com.flossom.common.core.constant.UserConstants;
import com.flossom.common.core.domain.entity.SysRole;
import com.flossom.common.core.domain.entity.SysTag;
import com.flossom.common.core.domain.entity.SysUser;
import com.flossom.common.core.domain.vo.TreeSelect;
import com.flossom.common.core.enums.TagTypeStatusEnum;
import com.flossom.common.core.exception.ServiceException;
import com.flossom.common.core.mapper.SysRoleMapper;
import com.flossom.common.core.mapper.SysTagMapper;
import com.flossom.common.core.text.Convert;
import com.flossom.common.core.utils.SpringUtils;
import com.flossom.common.core.utils.StringUtils;
import com.flossom.common.datascope.annotation.DataScope;
import com.flossom.common.security.utils.SecurityUtils;
import com.flossom.system.service.ISysTagService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 标签管理 服务实现
 *
 * @author flossom
 */
@Service
public class SysTagServiceImpl implements ISysTagService {
    @Autowired
    private SysTagMapper tagMapper;

    @Autowired
    private SysRoleMapper roleMapper;

    /**
     * 查询标签管理数据
     *
     * @param tag 标签信息
     * @return 标签信息集合
     */
    @Override
    @DataScope(deptAlias = "d")
    public List<SysTag> selectDeptList(SysTag tag) {
        return tagMapper.selectDeptList(tag);
    }

    /**
     * 查询标签树结构信息
     *
     * @param tag 标签信息
     * @return 标签树信息集合
     */
    @Override
    public List<TreeSelect> selectDeptTreeList(SysTag tag) {
        List<SysTag> tags = SpringUtils.getAopProxy(this).selectDeptList(tag);
        return buildDeptTreeSelect(tags);
    }

    /**
     * 构建前端所需要树结构
     *
     * @param tags 标签列表
     * @return 树结构列表
     */
    @Override
    public List<SysTag> buildDeptTree(List<SysTag> tags) {
        List<SysTag> returnList = new ArrayList<SysTag>();
        List<Long> tempList = tags.stream().map(SysTag::getId).collect(Collectors.toList());
        for (SysTag tag : tags) {
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(tag.getParentId())) {
                recursionFn(tags, tag);
                returnList.add(tag);
            }
        }
        if (returnList.isEmpty()) {
            returnList = tags;
        }
        return returnList;
    }

    /**
     * 构建前端所需要下拉树结构
     *
     * @param tags 标签列表
     * @return 下拉树结构列表
     */
    @Override
    public List<TreeSelect> buildDeptTreeSelect(List<SysTag> tags) {
        List<SysTag> deptTrees = buildDeptTree(tags);
        return deptTrees.stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    /**
     * 根据角色ID查询标签树信息
     *
     * @param roleId 角色ID
     * @return 选中标签列表
     */
    @Override
    public List<Long> selectDeptListByRoleId(Long roleId) {
        SysRole role = roleMapper.selectRoleById(roleId);
        return tagMapper.selectDeptListByRoleId(roleId, role.isDeptCheckStrictly());
    }

    /**
     * 根据标签ID查询信息
     *
     * @param id 标签ID
     * @return 标签信息
     */
    @Override
    public SysTag selectDeptById(Long id) {
        return tagMapper.selectDeptById(id);
    }

    /**
     * 根据ID查询所有子标签（正常状态）
     *
     * @param id 标签ID
     * @return 子标签数
     */
    @Override
    public int selectNormalChildrenDeptById(Long id) {
        return tagMapper.selectNormalChildrenDeptById(id);
    }

    /**
     * 是否存在子节点
     *
     * @param id 标签ID
     * @return 结果
     */
    @Override
    public boolean hasChildByDeptId(Long id) {
        int result = tagMapper.hasChildByDeptId(id);
        return result > 0;
    }

    /**
     * 查询标签是否存在用户
     *
     * @param id 标签ID
     * @return 结果 true 存在 false 不存在
     */
    @Override
    public boolean checkDeptExistUser(Long id) {
        int result = tagMapper.checkDeptExistUser(id);
        return result > 0;
    }

    /**
     * 校验标签名称是否唯一
     *
     * @param tag 标签信息
     * @return 结果
     */
    @Override
    public boolean checkDeptNameUnique(SysTag tag) {
        Long deptId = StringUtils.isNull(tag.getId()) ? -1L : tag.getId();
        SysTag info = tagMapper.checkDeptNameUnique(tag.getTagName(), tag.getParentId());
        if (StringUtils.isNotNull(info) && info.getId().longValue() != deptId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验标签是否有数据权限
     *
     * @param id 标签id
     */
    @Override
    public void checkDeptDataScope(Long id) {
        if (!SysUser.isAdmin(SecurityUtils.getUserId())) {
            SysTag tag = new SysTag();
            tag.setId(id);
            List<SysTag> tags = SpringUtils.getAopProxy(this).selectDeptList(tag);
            if (StringUtils.isEmpty(tags)) {
                throw new ServiceException("没有权限访问标签数据！");
            }
        }
    }

    /**
     * 新增保存标签信息
     *
     * @param
     * @return 结果
     */
    @Override
    public int insertDept(SysTag tag) {
        SysTag info = tagMapper.selectDeptById(tag.getParentId());
        // 如果父节点不为正常状态,则不允许新增子节点
//        if (!UserConstants.DEPT_NORMAL.equals(info.getStatus()))
//        {
//            throw new ServiceException("标签停用，不允许新增");
//        }
        if (Objects.isNull(info)) {
            tag.setAncestors("0");
            tag.setParentId(0l);
        } else {
            tag.setParentName(info.getTagName());
        }

        return tagMapper.insertDept(tag);
    }

    /**
     * 修改保存标签信息
     *
     * @param
     * @return 结果
     */
    @Override
    public int updateDept(SysTag tag) {
        SysTag newParentDept = tagMapper.selectDeptById(tag.getParentId());
        SysTag oldDept = tagMapper.selectDeptById(tag.getId());
        if (StringUtils.isNotNull(newParentDept) && StringUtils.isNotNull(oldDept)) {
            String newAncestors = newParentDept.getAncestors() + "," + newParentDept.getId();
            String oldAncestors = oldDept.getAncestors();
            tag.setAncestors(newAncestors);
            updateDeptChildren(tag.getId(), newAncestors, oldAncestors);
        }
        tag.setParentName(newParentDept.getTagName());
        int result = tagMapper.updateDept(tag);
        if (UserConstants.DEPT_NORMAL.equals(tag.getStatus()) && StringUtils.isNotEmpty(tag.getAncestors())
                && !StringUtils.equals("0", tag.getAncestors())) {
            // 如果该标签是启用状态，则启用该标签的所有上级标签
            updateParentDeptStatusNormal(tag);
        }
        return result;
    }

    /**
     * 修改该标签的父级标签状态
     *
     * @param
     */
    private void updateParentDeptStatusNormal(SysTag tag) {
        String ancestors = tag.getAncestors();
        Long[] deptIds = Convert.toLongArray(ancestors);
        tagMapper.updateDeptStatusNormal(deptIds);
    }

    /**
     * 修改子元素关系
     *
     * @param
     * @param newAncestors 新的父ID集合
     * @param oldAncestors 旧的父ID集合
     */
    public void updateDeptChildren(Long id, String newAncestors, String oldAncestors) {
        List<SysTag> children = tagMapper.selectChildrenDeptById(id);
        for (SysTag child : children) {
            child.setAncestors(child.getAncestors().replaceFirst(oldAncestors, newAncestors));
        }
        if (children.size() > 0) {
            tagMapper.updateDeptChildren(children);
        }
    }

    /**
     * 删除标签管理信息
     *
     * @param id 标签ID
     * @return 结果
     */
    @Override
    public int deleteDeptById(Long id) {
        return tagMapper.deleteDeptById(id);
    }

    @Override
    public List<TreeSelect> selectTagTreeList(SysTag tag) {
        List<SysTag> tags = SpringUtils.getAopProxy(this).selectDeptList(tag);
        return buildDeptTreeSelect(tags);
    }

    @Override
    public List<Map<String, Object>> getMiniProgramTags() {
        List<Map<String, Object>> tagList = new ArrayList<>();
        // 获取小程序标签
        List<SysTag> miniProgramTags = tagMapper.selectSecondTagByType(TagTypeStatusEnum.MINI_PROGRAM.getCode());
        if (miniProgramTags != null && miniProgramTags.size() > 0) {
            Map<String, Object> map;
            for (SysTag miniProgramTag : miniProgramTags) {
                map = new HashMap<>();
                map.put("label", miniProgramTag.getTagName());
                map.put("value", miniProgramTag.getId());
                tagList.add(map);
            }
        }
        return tagList;
    }

    @Override
    public List<Map<String, Object>> getWecomTags() {
        List<Map<String, Object>> tagList = new ArrayList<>();
        // 获取小程序标签
        List<SysTag> miniProgramTags = tagMapper.selectSecondTagByType(TagTypeStatusEnum.ENTERPRISE_WECHAT.getCode());
        if (miniProgramTags != null && miniProgramTags.size() > 0) {
            Map<String, Object> map;
            for (SysTag miniProgramTag : miniProgramTags) {
                map = new HashMap<>();
                map.put("label", miniProgramTag.getTagName());
                map.put("value", miniProgramTag.getId());
                tagList.add(map);
            }
        }
        return tagList;
    }

    /**
     * 递归列表
     */
    private void recursionFn(List<SysTag> list, SysTag t) {
        // 得到子节点列表
        List<SysTag> childList = getChildList(list, t);
        t.setChildren(childList);
        for (SysTag tChild : childList) {
            if (hasChild(list, tChild)) {
                recursionFn(list, tChild);
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private List<SysTag> getChildList(List<SysTag> list, SysTag t) {
        List<SysTag> tlist = new ArrayList<SysTag>();
        Iterator<SysTag> it = list.iterator();
        while (it.hasNext()) {
            SysTag n = (SysTag) it.next();
            if (StringUtils.isNotNull(n.getParentId()) && n.getParentId().longValue() == t.getId().longValue()) {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<SysTag> list, SysTag t) {
        return getChildList(list, t).size() > 0 ? true : false;
    }
}
